//
//  ListLeftVariableNumberedListBodyTextModel.swift
//  MVMCoreUI
//
//  Created by Subhankar Acharya on 12/06/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//


public class ListLeftVariableNumberedListBodyTextModel: ListItemModel, MoleculeModelProtocol {
    //-----------------------------------------------------
    // MARK: - Properties
    //-----------------------------------------------------
    
    public static var identifier: String = "listLVNLBdy"
    public var number: Int
    public var headlineBody: HeadlineBodyModel
    
    //-----------------------------------------------------
    // MARK: - Initializer
    //-----------------------------------------------------
    
    public init(number: Int, headlineBody: HeadlineBodyModel) {
        self.number = number
        self.headlineBody = headlineBody
        super.init()
    }
    
    //-----------------------------------------------------
    // MARK: - Keys
    //-----------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case number
        case headlineBody
    }
    
    //-----------------------------------------------------
    // MARK: - Codec
    //-----------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        number = try typeContainer.decode(Int.self, forKey: .number)
        headlineBody = try typeContainer.decode(HeadlineBodyModel.self, forKey: .headlineBody)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(number, forKey: .number)
        try container.encode(headlineBody, forKey: .headlineBody)
    }
}
